#include "config.h"
#include "qspi.h"
#include "w25qxx.h"

#define BAUD                (65536 - FOSC/4/115200)
#define DMA_AMT_LEN         256

BYTE xdata buf[4096];

void printf_buf()
{
    int i;

    for (i = 0; i < 256; i++)
    {
        if ((i % 32) == 0)
            printf("%04X: ", i);
        printf("%02bx ", buf[i]);
        if ((i % 32) == 31)
            printf("\n");
    }
    printf("\n");
}

void main()
{
    DWORD addr;
    WORD len;
    int i;

    P_SW2 = 0x80;
    WTST = 0x00;
    CKCON = 0x00;

    P0M0 = 0x00; P0M1 = 0x00;
    P1M0 = 0x00; P1M1 = 0x00;
    P2M0 = 0x00; P2M1 = 0x00;
    P3M0 = 0x00; P3M1 = 0x00;
    P4M0 = 0x00; P4M1 = 0x00;
    P5M0 = 0x00; P5M1 = 0x00;
    
    SCON = 0x52;
    T2L = BAUD;
    T2H = BAUD >> 8;
    AUXR = 0x15;

    QSPI_Init();
    W25Q_Enable_QE();
    
    printf("QSPI Read/Write Serial Flash !\n");
    
    _getkey();
    printf("%08lx\n", W25Q_ReadJEDECID_9F());

    addr = 0;
    len = 256;

    printf("Erase 4K !\n");
    W25Q_Erase4K_20(addr, TRUE);                    //4Kֽ
    
    printf("QSPI Read !\n");                        //QSPIʽȡ
    W25Q_FastRead_6B(addr, buf, len);
    printf_buf();
    
    printf("QSPI Program !\n");                     //QSPIʽ
    for (i = 0; i < len; i++) buf[i] = i;
//    W25Q_PageProgram_02(addr, buf, len);
    W25Q_PageProgram_32(addr, buf, len);
    
    printf("QSPI Read !\n");                        //QSPIʽȡ̺
    W25Q_FastRead_6B(addr, buf, len);   
    printf_buf();

    while (1);
}

